// ARG.PRG - Deals with command line arguments from Clipper.

STATIC aArgList:={}

//..........................................................
PROCEDURE ArgSet( aArgs )
   aArgList:= aArgs
RETURN

//..........................................................
FUNCTION ArgC()            // Argument Count
RETURN ( Len( aArgList ) )

//..........................................................
FUNCTION ArgV( nArg )      // Argument Value
   DO CASE
   CASE ( nArg == 0 )
//      RETURN( Program() )
   CASE ( nArg <= ArgC() ).AND.( nArg >=1 )
      RETURN( aArgList[ nArg ] )
   ENDCASE
RETURN("")

//..........................................................
// EOF: ARG.PRG
