
#include "inkey.ch"
//.............................................................
FUNCTION ASCII_Pick( nTr, nLc, nBr, nRc )
LOCAL nKey, n, bBlock, nRetVal
LOCAL b:= TBrowseNew( nTr, nLc, nBr, nRc )
PRIVATE i:= 1

   // Setup browse object
   b:goTopBlock:=    {|| i:= 1 }
   b:goBottomBlock:= {|| i:= 16 }
   b:skipBlock:=  {|n,r| r:= IIf(n>0,Min(n,16-i),Max(n,-(i-1))),i+= r, r }
   FOR n:= 0 TO 15
      bBlock:= &( "{|| Chr( 16 * (i-1) + " + LTrim( Str( n ) ) + " ) }" )
      b:addColumn( TBColumnNew( "", bBlock ) )
   NEXT

   // Process keystrokes; stabilize browse
   DO WHILE (.T.)
      DO WHILE ( !b:stabilize() )
         IF ( NextKey() <> 0 ); EXIT; ENDIF
      ENDDO
      nKey:= InKey(0)
      DO CASE
      CASE (nKey==K_UP);         b:up()
      CASE (nKey==K_DOWN);       b:down()
      CASE (nKey==K_LEFT);       b:left()
      CASE (nKey==K_RIGHT);      b:right()
      CASE (nKey==K_HOME);       b:goTop();    b:panHome()
      CASE (nKey==K_END);        b:goBottom(); b:panEnd()
      CASE (nKey==K_ENTER);      nRetVal:= ( 16 * (i-1) + ( b:colpos - 1 ) )
         EXIT
      CASE (nKey==K_ESC);        nRetVal:=  -1
         EXIT
      ENDCASE
   ENDDO
RETURN( nRetVal )

