/* FGETNEXT.PRG - Gets the next file handle.

   Returns the next file handle to be used.  Opens the DOS predefined
   NUL file because it should never have a problem using this one,
   unless out of handles, of course.

*/
#include "mks50.ch"
#define OUT_OF_HANDLES 4
//......................................................
FUNCTION FGetNext()
LOCAL nHandle:= FOpen( "NUL", 0 )
LOCAL nError:= FError()
   IF ( nHandle == -1 )
      IF ( nError <> OUT_OF_HANDLES )
        // I assume this will NEVER happen...
         ErrorAbort( "DOS Error (" + LStr( nError ) + ") opening NUL." )
        // Won't get this far....
      ENDIF
   ELSE
      FClose( nHandle )
   ENDIF
RETURN( nHandle )

//......................................................
// EOF: FGETNEXT.PRG
