// FIELD.PRG - Supply forgotten FieldXxxx()() functions.

#include "mks50.ch"
//............................................................
FUNCTION FieldType( nField )
RETURN ValType( FieldGet( nField ) )

//............................................................
FUNCTION FieldLen( nField )   // Length on disk in DBF file
LOCAL cType:= FieldType( nField ), nLen:= 0
   DO CASE
   CASE ( cType == "C" )
      nLen:= Len( FieldGet( nField ) )
   CASE ( cType == "N" )
      nLen:= Len( Str( FieldGet( nField ) ) )
   CASE ( cType == "D" )
      nLen:= 8
   CASE ( cType == "M" )
      nLen:= 10
   CASE ( cType == "L" )
      nLen:= 1
   ENDCASE
RETURN( nLen )

//............................................................
FUNCTION FieldDec( nField )   // Decimals for field in DBF file
LOCAL nDec:= 0, cFieldValue, nDecPos
   IF ( FieldType( nField ) == "N" )
      cFieldValue:= Str( FieldGet( nField ) )
      IF ( nDecPos:= At( ".", cFieldValue) ) > 0
         nDec:= Len( cFieldValue ) - nDecPos
      ENDIF
   ENDIF
RETURN( nDec )

//............................................................
// EOF: FIELD.PRG
