#include "mks50.ch"

#define FileName( f ) PadR( f[1], 12 )
#define FileSize( f ) Str( f[2], 10 )
#define FileDate( f ) DToC( f[3] )
#define FileTime( f ) f[4]

//.............................................................
FUNCTION SelectFile( cFileSpec, nTr, nLc )
LOCAL nKey, nBr:= nTr+12, nRc:= nLc+46
LOCAL cOldColor:= SetColor("GR+/B"), nRow:= Row(), nCol:= Col(),;
      cOldScreen:= WinSave( nTr, nLc, nBr, nRc )
LOCAL b:= TBrowseNew( ++nTr, nLc+=2, --nBr, nRc-=2 )
LOCAL aFiles:= Directory( cFileSpec ),i:= 1
LOCAL aFile:= NIL

   // Setup browse object
   b:goTopBlock:=    {|| i:= 1 }
   b:goBottomBlock:= {|| i:= Len(aFiles) }
   b:skipBlock:=     {|n,r| r:= IIf(n>0,Min(n,Len(aFiles)-i),Max(n,-(i-1))),i+= r, r }
   b:addColumn( TBColumnNew( "Name-------- ------Size --Date-- --Time--",;
                             {|| FileName( aFiles[i] ) + " " +;
                                 FileSize( aFiles[i] ) + " " +;
                                 FileDate( aFiles[i] ) + " " +;
                                 FileTime( aFiles[i] ) } ) )
/*
   b:addColumn( TBColumnNew( "Name--------", {|| FileName( aFiles[i] ) } ) )
   b:addColumn( TBColumnNew( "------Size",   {|| FileSize( aFiles[i] ) } ) )
   b:addColumn( TBColumnNew( "--Date--",     {|| FileDate( aFiles[i] ) } ) )
   b:addColumn( TBColumnNew( "--Time--",     {|| FileTime( aFiles[i] ) } ) )
*/
   // Process keystrokes; stabilize browse
   DO WHILE (.T.)
      DO WHILE ( !b:stabilize() )
         IF ( NextKey() <> 0 ); EXIT; ENDIF
      ENDDO
      nKey:= InKey(0)
      DO CASE
      CASE (nKey==K_UP);         b:up()
      CASE (nKey==K_DOWN);       b:down()
      CASE (nKey==K_PGUP);       b:pageUp()
      CASE (nKey==K_PGDN);       b:pageDown()
      CASE (nKey==K_HOME);       b:goTop()
      CASE (nKey==K_END);        b:goBottom()
      CASE (nKey==K_ENTER);      aFile:= aFiles[i]
         EXIT
      CASE (nKey==K_ESC);        aFile:= NIL
         EXIT
      ENDCASE
   ENDDO

   SetPos( nRow, nCol )
   SetColor( cOldColor )
   WinRest( cOldScreen )

RETURN( aFile )

//.............................................................
STATIC FUNCTION WinSave( nTr, nLc, nBr, nRc )
LOCAL cScr:= Chr(nTr)+Chr(nLc)+Chr(nBr)+Chr(nRc)+;
             SaveScreen( nTr, nLc, nBr, nRc )
   @ nTr, nLc CLEAR TO nBr, nRc
   @ nTr, nLc TO nBr, nRc DOUBLE
RETURN( cScr )

//.............................................................
#define Coord( s, n ) Asc( SubStr( s, n, 1 ) )
#define Screen( s )   SubStr( s, 5 )
STATIC PROCEDURE WinRest( cScr )
   RestScreen( Coord( cScr, 1 ), Coord( cScr, 2 ),;
               Coord( cScr, 3 ), Coord( cScr, 4 ),;
               Screen( cScr ) )
RETURN

//.............................................................
// EOF

/*
      DO CASE
      CASE (nKey==K_UP);         b:up()
      CASE (nKey==K_DOWN);       b:down()
      CASE (nKey==K_LEFT);       b:left()
      CASE (nKey==K_RIGHT);      b:right()
      CASE (nKey==K_CTRL_LEFT);  b:panLeft()
      CASE (nKey==K_CTRL_RIGHT); b:panRight()
      CASE (nKey==K_CTRL_PGUP);  b:goTop()
      CASE (nKey==K_CTRL_PGDN);  b:goBottom()
      CASE (nKey==K_PGUP);       b:pageUp()
      CASE (nKey==K_PGDN);       b:pageDown()
      CASE (nKey==K_HOME);       b:home()
      CASE (nKey==K_END);        b:end()
      CASE (nKey==K_CTRL_HOME);  b:panHome()
      CASE (nKey==K_CTRL_END);   b:panEnd()
      CASE (nKey==K_ENTER);      aFile:= aFiles[i]
         EXIT
      CASE (nKey==K_ESC);        aFile:= NIL
         EXIT
      ENDCASE
*/
