// ACHOICE.PRG

#include "mks50.ch"


//.............................................................
FUNCTION AChoice( nTr, nLc, nBr, nRc, aArray )
LOCAL nKey, nElement, i:= 1, tbc
LOCAL b:= TBrowseNew( nTr, nLc, nBr, nRc )

   // Setup browse object
   b:goTopBlock:=    {|| i:= 1 }
   b:goBottomBlock:= {|| i:= Len(aArray) }
   b:skipBlock:=     {|n,r| r:= IIf(n>0,Min(n,Len(aArray)-i),Max(n,-(i-1))),i+= r, r }
   tbc:= TBColumnNew( "", {|| aArray[i] } )
   tbc:width:= AWidth( aArray )
   b:addColumn( tbc )

   // Process keystrokes; stabilize browse
   DO WHILE (.T.)
      DO WHILE ( !b:stabilize() )
         IF ( NextKey() <> 0 ); EXIT; ENDIF
      ENDDO
      nKey:= InKey(0)
      DO CASE
      CASE (nKey==K_UP);         b:up()
      CASE (nKey==K_DOWN);       b:down()
      CASE (nKey==K_PGUP);       b:pageUp()
      CASE (nKey==K_PGDN);       b:pageDown()
      CASE (nKey==K_HOME);       b:goTop()
      CASE (nKey==K_END);        b:goBottom()
      CASE (nKey==K_ENTER);      nElement:= i
         EXIT
      CASE (nKey==K_ESC);        nElement:= 0
         EXIT
      ENDCASE
   ENDDO
RETURN( nElement )

