/* GETKEY.PRG - Shell for InKey() that checks SetKey().

   GetKey() accepts a numeric parameter identical in convention to the
   parmeter passed to InKey(). It calls InKey() and then checks
   SetKey() to see if there is a block associated with it. If so, it
   Eval()s the block and then calls InKey() again. If not, it returns
   the value recieved from InKey().

*/
#include "mks50.ch"

//......................................................
FUNCTION GetKey( nSeconds )
LOCAL nKey, bKeyBlock
   WHILE ( bKeyBlock:= SetKey( nKey:= InKey( nSeconds ) ) ) <> NIL
      Eval( bKeyBlock, ProcName(1), ProcLine(1), "" )
   ENDDO
RETURN( nKey )

//......................................................
// EOF: GETKEY.PRG
