#include "mks50.ch"

//...........................................................................
FUNCTION ObjCheck( _Obj, aChecks )
LOCAL nLen, i:= 1
   IF ( ValType( aChecks ) <> "A" )
      ErrorAbort( "Check failed: object not an array." )
   ENDIF
   nLen:= Len( aChecks )
   WHILE (i <= nLen)
      IF !Eval( aChecks[ i ], _Obj, _Obj[ ++i ] )
         ErrorAbort( "Check failed for object class: "  + ClassName( _Obj ) +;
                     " at attribute: " + LStr( --i ) + "." )
      ENDIF
   END
RETURN( _Obj )

//...........................................................................
// EOF: OBJECT.PRG
